package cn.cecep.talroad.service.impl;

import cn.cecep.talroad.domain.MonDevSnOther;
import cn.cecep.talroad.mapper.MonDevSnOtherMapper;
import cn.cecep.talroad.service.IMonDevSnOtherService;
import cn.cecep.talroad.vo.MonDevSnVO;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;




/**
 * 设备数据-水泥-其它时间 保存设备的小时以上的数据Service业务层处理
 *
 * @author szhpt
 * @date 2023-01-10*/
@Service
public class MonDevSnOtherServiceImpl extends ServiceImpl<MonDevSnOtherMapper,MonDevSnOther> implements IMonDevSnOtherService
{
    @Autowired
    private MonDevSnOtherMapper monDevSnOtherMapper;

    /**
     * 查询设备数据-水泥-其它时间 保存设备的小时以上的数据列表
     *
     * @param monDevSnOther 设备数据-水泥-其它时间 保存设备的小时以上的数据
     * @return 设备数据-水泥-其它时间 保存设备的小时以上的数据
     */
    @Override
    public List<MonDevSnOther> selectMonDevSnOtherList(MonDevSnOther monDevSnOther)
    {
        return monDevSnOtherMapper.selectMonDevSnOtherList(monDevSnOther);
    }

    @Override
    public List<MonDevSnVO> getDataPage(String factoryId, List<String> deviceIds, String timeType, String startTime, String endTime, String orderField, String orderType, Page page) {
        QueryWrapper<MonDevSnVO> queryWrapper = new QueryWrapper<MonDevSnVO>()
                .eq("r.factory_id", factoryId)
                .in("r.device_id", deviceIds)
                .eq("r.time_type", timeType)
                .ge("r.data_time", startTime)
                .le("r.data_time", endTime)
                .orderBy(StringUtils.isNotEmpty(orderField), "asc".equals(orderType), orderField, "r.data_id");
        return baseMapper.getDataPage(page, queryWrapper);
    }

}
